#pragma once

#ifdef INPMACRT_EXPORTS
#ifndef _WIN64
#define INPMACRT_API __declspec(dllexport)
#else
#define INPMACRT_API
#endif
#else
#define INPMACRT_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/******************************/
/* API FUNCTIONS              */
/******************************/
// sharedmemory acccess
int INPMACRT_API __stdcall	INpMacRt_ReadMemory( LPCTSTR pProcName, LPCTSTR pName, int Offset ,BYTE *lpData ,int Buff_Size );
int INPMACRT_API __stdcall	INpMacRt_WriteMemory( LPCTSTR pProcName, LPCTSTR pName, int Offset ,BYTE *lpData ,int Buff_Size );
int INPMACRT_API __stdcall	INpMacRt_GetSize( LPCTSTR pProcName, LPCTSTR pName );

// sharedmemory acccess unlimited
int INPMACRT_API __stdcall	INpMacRt_GetSizeEx( LPCTSTR pProcName, LPCTSTR pName, DWORD *pdwMemSize );
int INPMACRT_API __stdcall	INpMacRt_ReadMemoryEx( LPCTSTR pProcName, LPCTSTR pName, DWORD dwOffset, void *lpData, DWORD dwMaxSize, DWORD *pdwReadSize );
int INPMACRT_API __stdcall	INpMacRt_WriteMemoryEx( LPCTSTR pProcName, LPCTSTR pName, DWORD dwOffset, void *lpData, DWORD dwMaxSize, DWORD *pdwWriteSize );

#ifdef __cplusplus
}
#endif /* __cplusplus */


/******************************/
/* ERROR CODES                */
/******************************/
#define	E_INPMACRT_SYSTEM_DOWN			0x80020000
#define	E_INPMACRT_NOT_FOUND			0x80020001
#define	E_INPMACRT_INVALID_OFFSET		0x80020002
#define	E_INPMACRT_FAILED_ACCESS		0x80020003
#define	E_INPMACRT_INVALID_PARAM		0x80020004
#define	E_INPMACRT_NOT_EXECUTION		0x80020005
#define	E_INPMACRT_MEM_ALIGMENT			0x80020006

