
#include "stdafx.h"
#include "INpMacWin.h"


#pragma warning(disable:4996)

#define MAX_MEM_SIZE	65536

void	memdump(void *, size_t);
int		Calc_DataSize( int, int, int );
int		_MemDumpMenu(void);
int		_APITestMenu(void);



////////////////////////////////////////////////////////////////////////////
// @	CXbhB
// 	gp
// ߂l	0
////////////////////////////////////////////////////////////////////////////
int _tmain(int argc, _TCHAR* argv[])
{
	int		iID = 0;
	int		iSize = 0;
	HANDLE	hMap = 0;
	int		iOffset = 0;
	int		iBuffSize = 0;

	char	szKey[256]={0};
	WCHAR	MemName[32]={0};
	BYTE	*bData = NULL;


	printf("////////////////////////////////////////\n"
		   "//  INpMacWin SAMPLE\n"
		   "////////////////////////////////////////\n");

	while (1)
	{
		printf("\nSet menu (10:Menu list) >> ");

		gets(szKey);
		if ( szKey[0] == 0x00 ){
			continue;
		}

		iID = atoi(szKey);

		switch(iID){
			case 10:	// j[Xg
				printf( "** [ Menu ] *********************************\n" );
				printf( "** ID NAME             | ID NAME             \n" );
				printf( "**  1 API Test         |  2 Memory Dump      \n" );
				printf( "** 99 End                                    \n" ); 
				break;

			case 1:		// APIeXg@\
				_APITestMenu();
				break;
				

			case 2:		// _v@\
				_MemDumpMenu();
				break;

			case 99:	// End
				break;
		}

		// End
		if(iID == 99)
			break;
	}

	return 0;
}



////////////////////////////////////////////////////////////////////////////
// @	APĨeXgs܂B
// 	Ȃ
// ߂l	R}h
////////////////////////////////////////////////////////////////////////////
int _APITestMenu(void)
{
	int		iID = 0;
	int		iSize = 0;
	HANDLE	hMap = 0;
	int		iOffset = 0;
	int		iBuffSize = 0;

	char	szKey[256]={0};
	char	MemName[32]={0};
	BYTE	*bData = NULL;


	printf("****************************************\n"
		   "**  API Test\n"
		   "****************************************\n");

	while (1)
	{
		printf("\nSet API menu (10:Menu list) >> ");

		gets(szKey);
		if ( szKey[0] == 0x00 ){
			continue;
		}

		iID = atoi(szKey);

		switch(iID){
			case 10:	// APIeXgpj[Xg
				printf( "** [ API Menu ] *****************************\n" );
				printf( "** ID NAME             | ID NAME             \n" );
				printf( "**  1 CreateMemory     |  2 DeleteMemory     \n" );
				printf( "**  3 ReadMemory       |  4 WriteMemory      \n" );
				printf( "** 99 Back                                   \n" ); 
				break;

			case 1:		// CreateMemory
				memset(MemName,0,sizeof(MemName));
				printf("MemoryName --> ");
				gets(MemName);				

				printf("MemorySize --> ");
				gets(szKey);
				iBuffSize = (int)atoi(szKey);
				
				// [L̊m]
				// w肵ɑ݂ꍇ́A߂lɃANZX\Ȕ͈͂̏lԂ܂B
				iSize = INpMacWin_CreateMemory( &hMap, MemName, iBuffSize );

				printf( "iRet = %d(%08Xh) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap );
				if( iSize == ERROR_ALREADY_EXISTS ) printf("[%s] already exists.\n", MemName);
				break; 

			case 2:		// DeleteMemory

				// [L̉]
				iSize = INpMacWin_DeleteMemory( hMap );
				printf( "iRet = %d(%08Xh) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap );
				hMap = 0;
				break;

			case 3:		// ReadMemory

				printf("Offset     --> ");
				gets(szKey);				
				iOffset = (int)atoi(szKey);

				printf("Buff_Size  --> ");
				gets(szKey);
				iBuffSize = (int)atoi(szKey);
				bData = (BYTE *)malloc(iBuffSize);

				
				// [f[^̓Ǎ]
				iSize = INpMacWin_ReadMemory( hMap, iOffset, bData, iBuffSize );
				
				if( iSize < 0  ){
					printf("\nRead Memory error 0x%08X | HANDLE = 0x%X\n", iSize, (int)hMap);
				}
				else{
					printf("\nRead Memory = %d(0x%08X) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap);
					memdump(bData, iSize);
				}

				free(bData);
				break;

			case 4:		// WriteMemory
				
				printf("Offset     --> ");
				gets(szKey);				
				iOffset = (int)atoi(szKey);

				memset(szKey, 0x00, sizeof(szKey));
				printf("Set Data(MAX:256Byte) --> ");
				gets(szKey);
				iBuffSize = (int)strlen(szKey);
	
				// [f[^̏]
				iSize = INpMacWin_WriteMemory( hMap, iOffset, (BYTE *)szKey, iBuffSize );
				
				if( iSize < 0  ){
					printf("\nRead Memory error 0x%08X | HANDLE = 0x%X\n", iSize, (int)hMap);
				}
				else{
					printf("\nRead Memory = %d(0x%08X) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap);
					memdump(szKey, iSize);
				}

				break;

			case 99:	// End
				break;
		}

		// End
		if(iID == 99)
			break;
	}

	return iID;
}



////////////////////////////////////////////////////////////////////////////
// @	w肳ꂽ̃f[^̃_vs܂B
// 	Ȃ
// ߂l	R}h
////////////////////////////////////////////////////////////////////////////
int _MemDumpMenu(void)
{
	int		iID = 0;
	int		iSize = 0;
	HANDLE	hMap = 0;
	int		iOffset = 0;
	int		iBuffSize = 0;

	char	szKey[256]={0};
	char	MemName[256]={0};
	BYTE	*bData = NULL;


	printf("****************************************\n"
		   "**  Memory Dump\n"
		   "****************************************\n");

	while (1)
	{
		printf("\nSet Dump menu (10:Menu list) >> ");

		gets(szKey);
		if ( szKey[0] == 0x00 ){
			continue;
		}

		iID = atoi(szKey);

		switch(iID){
			case 10:	// _vpj[Xg
				printf( "** [ Menu ] *********************************\n" );
				printf( "** ID NAME                                   \n" );
				printf( "**  1 Dump Start                             \n" );
				printf( "** 99 Back                                   \n" ); 
				break;

			case 1:
				// L@
				memset(MemName,0,sizeof(MemName));
				printf("MemoryName (MAX:12byte)  --> ");
				gets(MemName);	

				// ItZbg@
				printf("Offset       (MAX:%d)  --> ", MAX_MEM_SIZE-1);
				gets(szKey);				
				iOffset = (int)atoi(szKey);
				
				// _vTCY@
				printf("Dump_Size    (MAX:%d)  --> ",MAX_MEM_SIZE);
				gets(szKey);
				iBuffSize = (int)atoi(szKey);


				// =======================================================================================
				// [L̊m]
				// w肵ɑ݂ꍇ́A߂lɃANZX\Ȕ͈͂̏lԂ܂B
				iSize = INpMacWin_CreateMemory( &hMap, MemName, iBuffSize );
				if (iSize < 0 ) {
					INpMacWin_DeleteMemory( hMap );
					printf( "MapMemory(open) Error = %d(%08Xh) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap );
					break; 					
				}

				// =======================================================================================
				// [L̎Q]
				// ߂lɃ}bṽANZX\Ȕ͈͂̏lԂ܂B
				iSize = INpMacWin_MapMemory( hMap, (LPVOID *)&bData );
				if (iSize < 0 ) {
					printf( "MapMemory(mapping) Error = %d(%08Xh) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap );
					INpMacWin_DeleteMemory( hMap );
					hMap = 0;
					break; 					
				}	

				//********************************
				// [f[^̃_v]
				printf( "----------------------\n" );
				printf( "MEM_SZ = %d(%08Xh) | HANDLE = 0x%X | ADDR = 0x%X\n", iSize, iSize, (int)hMap, (int)bData );
				printf( "----------------------\n" );
				iSize = Calc_DataSize( iOffset, iBuffSize, iSize );	
				printf( "Dump_Size = %d(%08Xh)\n", iSize, iSize );
				memdump( &bData[iOffset], iSize);		
				printf( "----------------------\n" );		
				//********************************

				// =======================================================================================
				// [L̎QƏI] 
				iSize = INpMacWin_UnMapMemory( (LPVOID)bData );
				if (iSize < 0 )	{
					printf( "UnMapMemory Error = %d(%08Xh) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap );
					INpMacWin_DeleteMemory( hMap );
					hMap = 0;
					break; 					
				}
				// =======================================================================================
				// [L̉]
				iSize = INpMacWin_DeleteMemory( hMap );
				if (iSize < 0 ) {
					printf( "DeleteMemory Error = %d(%08Xh) | HANDLE = 0x%X\n", iSize, iSize, (int)hMap );
				}
				
				hMap = 0;
				break;

			case 99:	// End
				break;
		}

		// End
		if(iID == 99)
			break;
	}

	return iID;
}





////////////////////////////////////////////////////////////////////////////
// @	f[^擾TCYZo܂B
// 	ofs			ItZbg
//			sz			obt@̃TCY
//			max			wGA()̃ANZXłőTCY
// ߂l	Zof[^TCY
///////////////////////////////////////////////////////////////////////////////
int	Calc_DataSize( int ofs, int sz, int max )
{

	if( (max - ofs) > sz )	return sz;
	else					return (max - ofs);

}


////////////////////////////////////
// DUMP
void memdump(void * data,size_t size)
{
	UINT		lp1,lp2;
	char		buff[80];
	char		line[80];
	
	for(lp1=0;lp1<(size+15)/16;lp1++){
		line[0]='\0';
		sprintf(buff,"%03X0: ",lp1);
		strcat(line,buff);
		for(lp2=0;lp2<16;lp2++){
			if((lp1*16+lp2)<size){
				sprintf(buff,"%02X ",*((BYTE *)data+lp1*16+lp2));
				strcat(line,buff);
			}
			else
				strcat(line,"   ");
		}
		for(lp2=0;(lp2<16)&&((lp1*16+lp2)<size);lp2++){
			if((*((BYTE *)data+lp1*16+lp2)>=32)&&(*((BYTE *)data+lp1*16+lp2)<=127)){
				sprintf(buff,"%c",*((BYTE *)data+lp1*16+lp2));
				strcat(line,buff);
			}
			else
				strcat(line,".");
		}
		strcat(line,"\x0d\x0a");
		printf(line);
	}
}
